/* Copyright 2007 You may not modify, use, reproduce, or distribute this software except in compliance with the terms of the License at:
 http://developer.sun.com/berkeley_license.html
 $Id: component.js,v 1.0 2007/04/15 19:39:59 gmurray71 Exp $
*/

jmaki.namespace("jmaki.widgets.flickr.gallery");

jmaki.widgets.flickr.gallery.Widget = function(wargs) {

    var _widget = this;
    var subscribe = ["/flickr/gallery", "/imageviewer"];
    var topic = "/flickr/gallery/showPhotos";
    var columns = 3;
    var count = 9;
    var isize = 75;
    var tag = "theKt";
    
    
    var fs = new jmaki.FlickrProxySearch(jmaki.xhp,topic);
        
    if (typeof wargs.args != 'undefined') {
        if  (typeof wargs.args.topic == 'undefined') {
            topic = "flickrSearch";
        } else {
            topic = wargs.args.topic;
        }
        if  (typeof wargs.args.columns != 'undefined') {
            columns = Number(wargs.args.columns);
        }
        if  (typeof wargs.args.count != 'undefined') {
            count = Number(wargs.args.count);
        }
        if  (typeof wargs.args.tag != 'undefined') {
            tag = wargs.args.tag;
        }
        if  (typeof wargs.args.size != 'undefined') {
            isize = Number(wargs.args.size);
        }  
    }
         
    if (wargs.subscribe){
        if (typeof wargs.subscribe == "string") {
            subscribe = [];
            subscribe.push(wargs.subscribe);
        } else {
            subscribe = wargs.subscribe;
        }
    }         
	
    this.showPhotos = function(photos) {
         var targetDiv = document.getElementById(wargs.uuid + "_flickrResults");         
        // clear out the children
        for (var l = targetDiv.childNodes.length -1; l >= 0; l--) {
            targetDiv.removeChild(targetDiv.childNodes[l]);    
        }
        var row;
        var length = count;

        if (photos.items && photos.items.length < count) {
            length = photos.items.length;
        }

        for (var i =0; i < length; i++) {  	
             if (i % columns == 0) {
                if (typeof targetDiv.insertRow != 'undefined') {
                    row = targetDiv.insertRow(targetDiv.rows.length);
                } else {
                    row = document.createElement("tr");
                    targetDiv.appendChild(row);
                }
            }
            var cell;
            if (typeof row.insertCell != 'undefined') {
                cell = row.insertCell(0);
            } else {
                cell = document.createElement('td');
                row.appendChild(cell);
            }
            var target = document.createElement("a");
            target.href =  photos.items[i].url;
            target.title = photos.items[i].title;
            target.target = "_jmaki";
            target.innerHTML = "<img src='" + photos.items[i].smallURL +
               "' border='0' height='" + isize + "' width='" + isize +"'>";
            cell.appendChild(target);
        }
    }

    this.searchPhotos = function(args) {
        if (args.value) args = args.value;
        fs.searchPhotos(args);
    };

    function doSubscribe(topic, handler) {
        var i = jmaki.subscribe(topic, handler);
        _widget.subs.push(i);     
    }

    this.destroy = function() {
        for (var i=0; _widget.subs && i < _widget.subs.length; i++) {
            jmaki.unsubscribe(_widget.subs[i]);
        }       
    };  
    
    this.postLoad = function() {
        _widget.subs = [];  
        for (var _i=0; _i < subscribe.length; _i++) {
            doSubscribe(subscribe[_i]  + "/loadTags", _widget.searchPhotos);
            doSubscribe(subscribe[_i]  + "/searchPhotos", _widget.searchPhotos);
            doSubscribe(subscribe[_i]  + "/showPhotos", _widget.showPhotos);
        } 
        _widget.searchPhotos(tag);
        
    };
}